=== debian/changelog ===
bctoolbox (5.3.105-1) unstable; urgency=medium

  * New upstream version 5.3.105

 -- Victor Seva <vseva@debian.org>  Sun, 23 Feb 2025 00:29:31 +0100
