=== debian/control ===
Source: bctoolbox
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders:
 Bernhard Schmidt <berni@debian.org>,
 Victor Seva <vseva@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libdecaf-dev,
 libmbedtls-dev,
Standards-Version: 4.6.2
Section: libs
Homepage: https://gitlab.linphone.org/BC/public/bctoolbox
Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/bctoolbox.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/bctoolbox
Description: Helper code for software by Belledonne Communications

# libbctoolbox-dev must be the first package for
# upstream-version-from-changelog to get installed into it
Package: libbctoolbox-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libbctoolbox2 (= ${binary:Version}),
 ${misc:Depends},
Description: Helper code for software by Belledonne Communications (development headers)
 The package provides a C/C++ utility library used by Linphone and other
 software by Belledonne Communications. The library offers platform independent
 implementations of cryptographic functions, exception handling, logging
 modules, file access, unit tests and data structures like lists and maps.
 .
 The package is probably not useful outside the Belledonne Communications suite
 of libraries and programs.
 .
 This package contains the development headers.

Package: libbctoolbox2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Helper library for software by Belledonne Communications (shared library)
 The package provides a C/C++ utility library used by Linphone and other
 software by Belledonne Communications. The library offers platform independent
 implementations of cryptographic functions, exception handling, logging
 modules, file access, unit tests and data structures like lists and maps.
 .
 The package is probably not useful outside the Belledonne Communications suite
 of libraries and programs.
 .
 This package contains the shared library.
