=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/archive\/(\d\S+)\/bctoolbox.*\.tar\.gz/bctoolbox-$1\.tar\.gz/g \
  https://gitlab.linphone.org/BC/public/bctoolbox/tags?sort=updated_desc .*/archive/([\d\.]+)/.*\.tar\.gz.*
